/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Download Statusbar.
 *
 * The Initial Developer of the Original Code is
 * Devon Jensen.
 *
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Devon Jensen <velcrospud@hotmail.com>
 *
 * Parts of some functions are based on similar functions in downloadpanel.js 
 * and nsProgressDialog.js found in Phoenix/Firebird build Jan.26, 2003.
 * Contributors to those projects are respectively: <unknown> and <Bill Law
 * and Aaron Kaluszka>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


var db_gDownloadManager;
var db_currentelem;
var db_requests = new Array( );
var db_paused = new Array( );
var db_displayprefs = new Array ( );
var db_totalFinished;
var db_totalSize;
window.addEventListener("load", downbarinit, true);
window.addEventListener('close', downbarclose, true);
var lastID = "nothing";
var db_datasource;
	
//var acs = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);

function downbarinit() {
	
  	window.removeEventListener("load", downbarinit, true);
	
	var downbarelem = document.getElementById("downbar");
	
	const db_dlmgrContractID = "@mozilla.org/download-manager;1";
	const db_dlmgrIID = Components.interfaces.nsIDownloadManager;
	db_gDownloadManager = Components.classes[db_dlmgrContractID].getService(db_dlmgrIID);
	
	const rdfSvcContractID = "@mozilla.org/rdf/rdf-service;1";
	const rdfSvcIID = Components.interfaces.nsIRDFService;
	gRDFService = Components.classes[rdfSvcContractID].getService(rdfSvcIID);
	
	var gIOService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var profile = Components.classes["@mozilla.org/profile/manager;1"].getService(Components.interfaces.nsIProfileInternal);
	var gProfileDirURL = gIOService.newFileURI(profile.getProfileDir(profile.currentProfile));
	
	db_datasource = gRDFService.GetDataSource("file://" + gProfileDirURL.path + "downloads.rdf");
		
	downbarelem.database.AddDataSource(db_datasource);
	downbarelem.builder.rebuild();
	
	db_totalFinished = 0;
	db_totalSize = 0;
	
	readPrefs();
	setAllDisplayItems();
	//checkHeight();
	//toJavaScriptConsole();
	
	checkChildren();
	window.setInterval("checkChildren()", 1000);
}

function downbarclose(aEvent) {
	
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	
	try {
		var dialogsOpen = pref.getBoolPref("downbar.function.dialogsOnClose");
		var clearnow = pref.getBoolPref("downbar.function.clearOnClose");
	} catch (e) {}
	
	// If there are still downloads in progress, expand them to a window
	// Need to check if this is the last main window
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var winEnum = wm.getEnumerator("navigator:browser");
	var count = 0;
	while (winEnum.hasMoreElements()) {
		winEnum.getNext();
		++count;
	}
		
	if (count == 1) {      // there is only one browser window and it is closing
	
		if (dialogsOpen) {
			aEvent.preventDefault();
			var dbelems = document.getElementById("downbar").childNodes;
			var progCount = 0;
			for (i = 1; i <= dbelems.length - 1; ++i) {
				if (dbelems[i].getAttribute("context") == "progresscontext") {
					++progCount;
					if (db_paused[i]) db_requests[i].resume();						
						
					var fixedelmpath = dbelems[i].id.replace(/\\/g, "\\\\");  // The \ and ' get messed up in the command if they are not fixed
					fixedelmpath = fixedelmpath.replace(/\'/g, "\\\'");	
					
					// Need to stagger the opening of the dialogs
					window.setTimeout("openProgDia('" + fixedelmpath + "'," + false + ")", progCount*500); // fix this, the false does nothing
				}    
			}
		}
		
		// close the window after all the progress dialogs
		window.setTimeout(function () {window.close();}, (progCount)*500+50); 
		
		// Clear downloads on close PREF
		if (clearnow) removeit(null, true);
	}
	else
		window.close();
}

function openProgDia(idtoexpand, nothing) {
	db_gDownloadManager.openProgressDialogFor(idtoexpand, window);
}

/*  const db_dlObserver = {
  observe: function(subject, topic, state) {
  	
  	//acs.logStringMessage(topic);
	
	var db_dl = subject.QueryInterface(Components.interfaces.nsIDownload);
  	
	if (topic == "dl-start") {
		db_dl.listener = dbListener;
		window.setTimeout("checkHeight()", 100);
	}
	
	if (topic == "dl-done") {
		
		// add a small animation or blink with PREF
		
		// Count how many finished downloads
		db_totalFinished = db_totalFinished + 1;
				
		var elmpath = db_dl.target.path;
		var aElem = document.getElementById(elmpath);
		
		try {  // in a try block because images from cache won't have a pSavedBytes
			// Count the size of finished downloads
			if (aElem.pSavedBytes) {
				if (aElem.pTotalBytes == "-1" | !aElem.pTotalBytes) 
					db_totalSize = db_totalSize + parseInt(aElem.pSavedBytes / 1024);  // KB
				else
					db_totalSize = db_totalSize + parseInt(aElem.pTotalBytes / 1024);  // KB
			}
		} catch (e) {}

		//Prefs for auto remove
		var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		try {
			var autoDremove = pref.getBoolPref("downbar.download.autoRemove");
			var Daftersec = pref.getIntPref("downbar.download.timeToClear");
			var autoIremove = pref.getBoolPref("downbar.image.autoRemove");
			var Iaftersec = pref.getIntPref("downbar.image.timeToClear");
		}
		catch (e) {}
		
		// check if it's an image, if image autoclear, set timeout to remove it
		var db_fileext = elmpath.split(".").pop().toLowerCase();
		if (db_fileext == "jpg" | db_fileext == "gif" | db_fileext == "jpeg" | db_fileext == "png" | db_fileext == "bmp") {
			if (autoIremove) {
				var fixedelmpath = elmpath.replace(/\\/g, "\\\\");  // The \ and ' get messed up in the command if they are not fixed
				fixedelmpath = fixedelmpath.replace(/\'/g, "\\\'");
				window.setTimeout("removeit('" + fixedelmpath + "'," + false + ")", Iaftersec*1000);
			}
		}
    	
    	// all other downloads auto remove
    	else if (autoDremove) {
	    		var fixedelmpath = elmpath.replace(/\\/g, "\\\\");
	    		fixedelmpath = fixedelmpath.replace(/\'/g, "\\\'");
				window.setTimeout("removeit('" + fixedelmpath + "'," + false + ")", Daftersec*1000);
		}
    	
    }
  }
} */

const dbListener = {
		onStateChange : function(aWebProgress, aRequest, aStateFlags, aStatus) {
			
			// I wanted to use this for after download functions but it doesn't send a Request. BUG? (with the URL to identify which element completed!)
			
			/* // Download is finished - check prefs to get rid of it - moved here for mozilla compatibility - instead of using firebird only "dl-done"
			if (aStateFlags == 16) {  // The state flag for STATE_STOP is hex 0x10 - see nsiwebprogresslistener.idl for others
				acs.logStringMessage("gotin");
				// Get a reference to the element in question
				var dbelems = document.getElementById("downbar").childNodes;
				var doneElem;
				var i = 1;
				acs.logStringMessage(aRequest);
				while (i < dbelems.length) {
					acs.logStringMessage(i);
					if (dbelems[i].getAttribute("pURL") == aRequest.name) {
						doneElem = dbelems[i];
						acs.logStringMessage("setit");
					}
					i = i + 1;
				}

				for (i = 1; i <= dbelems.length - 1; ++i) {
					acs.logStringMessage(dbelems[i].getAttribute("pURL"));
					if (dbelems[i].getAttribute("pURL") == aRequest.name) {
						doneElem = dbelems[i];
					}
				}
				if (!doneElem) {return;}
		  	}*/
		
		},
		
		onProgressChange : function(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress){

			// Store a reference to its request, find out which element this is for
			var dbelems = document.getElementById("downbar").childNodes;
			var progElem;
			var index;
			var isPaused;
			if (!aRequest) {return;}    // need to fix in Firebird
			
			for (i = 1; i <= dbelems.length - 1; ++i) {
				if (dbelems[i].getAttribute("pURL") == aRequest.name) {
					// Add if statement - if (!db_requests[i]) then set the request 
					db_requests[i] = aRequest;
					progElem = dbelems[i];
					index = i;
					isPaused = db_paused[i];
				}
			}
			if (!progElem) {return;}
						
			var now = ( new Date() ).getTime();
			
			// If the element has the default value for speed, it is new, set all displays
			if (progElem.lastChild.lastChild.firstChild.nextSibling.value == "1") {
				setAllDisplayItems();
				//checkHeight();
			}
			
			// If we don't have any info saved yet, save the current info and return
			if (!progElem.pSavedBytes | !progElem.pLastUpdate) {
				progElem.pSavedBytes = aCurTotalProgress;
				progElem.pLastUpdate = now;
				return;
			}
			
			// Don't want to update the speed if it is paused
			if (isPaused) {return;}
			
			if (aCurTotalProgress == aMaxTotalProgress) {
				
					// Count how many finished downloads
					db_totalFinished = db_totalFinished + 1;
					
					try {  // in a try block because images from cache won't have a pSavedBytes
						// Count the size of finished downloads
						if (progElem.pSavedBytes) {
							if (progElem.pTotalBytes == "-1" | !progElem.pTotalBytes) 
								db_totalSize = db_totalSize + parseInt(progElem.pSavedBytes / 1024);  // KB
							else
								db_totalSize = db_totalSize + parseInt(progElem.pTotalBytes / 1024);  // KB
						}
					} catch (e) {}
					
					var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
					try {
						var autoDremove = pref.getBoolPref("downbar.download.autoRemove");
						var Daftersec = pref.getIntPref("downbar.download.timeToClear");
					}
					catch (e) {}
					if (autoDremove) {
			    		var fixedelmpath = progElem.id.replace(/\\/g, "\\\\");
			    		fixedelmpath = fixedelmpath.replace(/\'/g, "\\\'");
						window.setTimeout("removeit('" + fixedelmpath + "'," + false + ")", Daftersec*1000);
					}
					
			}
			
			// interval ADD PREF?
			if (now - progElem.pLastUpdate > 1000) {
				
				// Calculate speed (for both determined and undetermined downloads)
				var oldrate = parseInt(progElem.lastChild.lastChild.firstChild.nextSibling.value);
				var elapsed = now - progElem.pLastUpdate;
				var rate = ((aCurTotalProgress - progElem.pSavedBytes)* 1000 ) / elapsed;
				var kRate = parseInt(rate / 1024); // KBytes/sec
				
				// Use average of the last two intervals so the speed doesn't jump around as much
				var avgrate = (kRate + oldrate) / 2;
	        	var fraction = parseInt( ( avgrate - ( avgrate = parseInt( avgrate ) ) ) * 10);
	        	var newrate = avgrate + "." + fraction;
	        	//acs.logStringMessage(oldrate + " + " + kRate + " /2 = " + newrate);
				progElem.lastChild.lastChild.firstChild.nextSibling.value = newrate;
				
				// Fix and set the size downloaded so far
				if (db_displayprefs[2]) {
					var currkb = parseInt(aCurTotalProgress / 1024); // KBytes
					progElem.lastChild.lastChild.lastChild.previousSibling.value = currkb + " KB";
				}
				
				// the the mode is undetermined, just count up the MB
				if (aMaxTotalProgress == "-1" | parseInt(aCurTotalProgress) > parseInt(aMaxTotalProgress) ) {
					
					//progElem.lastChild.lastChild.firstChild.hidden = true;
					//progElem.lastChild.lastChild.firstChild.nextSibling.hidden = true;
					//progElem.lastChild.lastChild.lastChild.previousSibling.hidden = false;
					//progElem.lastChild.lastChild.lastChild.hidden = true;
					
					
					// Percent and remaining time will be unknown
					progElem.lastChild.lastChild.firstChild.value = "Unk.";
					progElem.lastChild.lastChild.lastChild.value = "Unk.";
					
					//someBytes = aCurTotalProgress / 1024 / 1024;
					//var mBfrac = parseInt( ( someBytes - ( someBytes = parseInt( someBytes ) ) ) * 10);
					//progElem.lastChild.lastChild.lastChild.previousSibling.value = "Unk. " + someBytes + "." + mBfrac + " MB";
					progElem.pSavedBytes = aCurTotalProgress;
					progElem.pTotalBytes = aMaxTotalProgress;
					progElem.pLastUpdate = now;
					return;
				}
				
				// Calculate percent 
					//- do it here because of a bug in dlmanager that makes negitive percentages with large files
				var currpercent = parseInt(aCurTotalProgress * 100 / aMaxTotalProgress);
				progElem.firstChild.setAttribute("value", currpercent);
				progElem.lastChild.lastChild.firstChild.setAttribute("value", (currpercent + "%"));
				
				// Calculate and set the remaining time
				if (db_displayprefs[3]) {
					var remainingkb = parseInt((aMaxTotalProgress - aCurTotalProgress) / 1024);
					var secsleft = (1 / newrate) * remainingkb;
					var remaintime = formatSeconds(secsleft);
					progElem.lastChild.lastChild.lastChild.value = remaintime;
				}
				// Got our info, now grab new values
				progElem.pSavedBytes = aCurTotalProgress;
				progElem.pTotalBytes = aMaxTotalProgress;
				progElem.pLastUpdate = now;
			}
			
		},
		
		onLocationChange : function(aWebProgress, aRequest, aLocation) {
		},
		
		onStatusChange : function(aWebProgress, aRequest, aStatus, aMessage) {
		},
		
		onSecurityChange : function(aWebProgress, aRequest, aState) {
		//acs.logStringMessage("sec change");
		}
}


function Commandswitcher(aCommand)  {

    switch (aCommand) {
    case "cmd_db_openfinished":
      openfinished(db_currentelem);
      break;
    case "cmd_db_showfile":
      showfile(db_currentelem);
      break;
    case "cmd_db_paures":
      pauseresumeTog(document.getElementById(db_currentelem), null);
      break;  
    /*case "cmd_db_viewprop":
      viewprop(db_currentelem);
      break;*/
    case "cmd_db_remove":
      removeit(db_currentelem, false);
      break;
    case "cmd_db_delete":
      deleteit(db_currentelem);
      break;  
	case "cmd_db_cancel":
      cancelprogress(db_currentelem);
      break;
    case "cmd_db_copyURL":
      copyURL(db_currentelem);
      break;
    case "cmd_db_start":
      startit(db_currentelem);
      break;
    case "cmd_db_stop":
      stopit(db_currentelem);
      break;
    case "cmd_db_hide":
      hideit(db_currentelem);
      break;     
    /*case "cmd_db_expand":
      expandtowindow(db_currentelem);
      break; */ 
    default:
    }
}  

function openfinished(elemtoopen) {
	var file = createLocalFile(elemtoopen);
    file.launch();
    var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	try {
		var removeOnOpen = pref.getBoolPref("downbar.function.removeOnOpen");
		if (removeOnOpen) removeit(elemtoopen);
	} catch (e) {}
    
}

function showfile(idtoshow) {
	var file = createLocalFile(idtoshow);
    file.reveal();
    var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	try {
		var removeOnShow = pref.getBoolPref("downbar.function.removeOnShow");
    	if (removeOnShow) removeit(idtoshow);
	} catch (e) {}
}

function pauseresumeTog(elem, aEvent) {
	try {
		if (aEvent.button == 2)	return;
	}
	catch (e) {}
		
	var dbelems = document.getElementById("downbar").childNodes;
	var request;
	var index;
	for (i = 1; i <= dbelems.length - 1; ++i) {
		if (dbelems[i] == elem) {
			request = db_requests[i];
			index = i;
			//acs.logStringMessage(request.name + " " + i);
		}
	}
	if (!request) {return;}
	
	if (db_paused[index]) {
		request.resume();
		db_paused[index] = false;
		elem.pPaused = false;
		elem.setAttribute("style", "border: 1px solid threeDShadow;");
		// remove the paused indication on tooltip
	}
	else {
		request.suspend();
		db_paused[index] = true;
		elem.pPaused = true;
		elem.setAttribute("style", "border: 1px solid red;");
		elem.lastChild.lastChild.firstChild.nextSibling.value = "0"
		// add a visual paused indication to tooltip
	}
}

/*function viewprop(idtoview) {
	window.openDialog("chrome://browser/content/downloads/downloadProperties.xul",
                        "_blank", "modal,centerscreen,chrome,resizable=no", idtoview);
}*/

// this does both remove one and remove all, depending on passed value - allofthem
function removeit(idtoremove, allofthem){
	
	var downbarelem = document.getElementById("downbar");
	var dbelems = document.getElementById("downbar").childNodes;
	
    // fix the request and paused array
    if (allofthem) {
		for (i = 1; i <= dbelems.length - 1; ++i) {
			if (dbelems[i].getAttribute("context") == "donecontext") {
				db_requests.splice(i,1);
				db_paused.splice(i,1);
			}
		}
	}
    else {
    	for (i = 1; i <= dbelems.length - 1; ++i) {
			if (dbelems[i].id == idtoremove) {
				db_requests.splice(i,1);
				db_paused.splice(i,1);
			}
		}
    }
    
	// Now to the removal business
	db_gDownloadManager.startBatchUpdate();
	
	try {																		// New = May 23, 2003 build and later
		db_datasource.beginUpdateBatch();  														// New
	} catch (e) {
		var observer = downbarelem.builder.QueryInterface(Components.interfaces.nsIRDFObserver);					// Old
    	var ds = downbarelem.database;																				// Old
    	observer.beginUpdateBatch(ds);																				// Old
	}
	
	if (allofthem) {
		var comparray = downbarelem.getElementsByAttribute("context", "donecontext");
		for (i = 1; i <= comparray.length - 1; ++i) {
			try {
        		db_gDownloadManager.removeDownload(comparray[i].id);
        	} catch (e) {}
        	//downbarelem.removeChild(document.getElementById(comparray[i].id)); //hmm, this doesn't work right have to rebuild instead
        }
	}
	else {
		try {
			db_gDownloadManager.removeDownload(idtoremove);
		} catch (e) {}
		//downbarelem.removeChild(document.getElementById(idtoremove));
	}
	
	try {
		db_datasource.endUpdateBatch();															// New
	} catch (e) {
		observer.endUpdateBatch(ds);																				// Old
		var remote = db_datasource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);					// Old
    	remote.Flush();																								// Old
    }
    
    db_gDownloadManager.endBatchUpdate();
    downbarelem.builder.rebuild();  // Would prefer to use removechild above but it doesn't work quite right when you download a file you already removed
    
    // Since the downbar was rebuilt, need to set the diplay again
    setAllDisplayItems();
    //checkHeight();
}

function deleteit(elemtodelete) {
	
	var file = createLocalFile(elemtodelete);
    var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	try {
		var askOnDelete = pref.getBoolPref("downbar.function.askOnDelete");
	} catch (e) {}
	if (askOnDelete)  {
		if (!confirm("Are you sure you wish to delete this file from your system?"))
			return;
	}
		
	removeit(elemtodelete);
	if (file.exists())
		file.remove(false); // false is the recursive setting
	
}

function cancelprogress(elemtocancel) {
	//var dbelems = document.getElementById("downbar").childNodes;   // need to fix in Firebird
	//for (i = 1; i <= dbelems.length - 1; ++i) { 
	//	if (dbelems[i].id == elemtocancel) {
	//		db_requests.splice(i,1);			// These array fixes aren't necessary b/c the remove function will do it
	//		db_paused.splice(i,1);
	//	}
	//}
	db_gDownloadManager.cancelDownload(elemtocancel);
	//checkHeight();
	// Downloads are left in state 3 when canceled, Must be removed too.
	removeit(elemtocancel, false);
}

function cancelall() {
	var dbelems = document.getElementById("downbar").childNodes;
	var cancPos = new Array( ); // hold the child positions of elements that are canceled, so that they can be removed in the 2nd for loop
	var posCount = 1;
	for (i = 1; i <= dbelems.length - 1; ++i) {
			if (dbelems[i].getAttribute("context") == "progresscontext") {
				db_requests.splice(i,1);
				db_paused.splice(i,1);
				db_gDownloadManager.cancelDownload(dbelems[i].id);
				cancPos[posCount] = i;
				++posCount;
			}
	}
	// Need to remove them after the first for loop is complete
	for (j = 1; j <= posCount-1; ++j) {								// need to fix in Firebird
		removeit(dbelems[cancPos[j]].id, false);
	}
	//checkHeight();
}

function pauseall() {
	var dbelems = document.getElementById("downbar").childNodes;
	var i = 1;
	// I don't know why a for loop won't work here but okay
	while (i < dbelems.length) {
		
		if (dbelems[i].getAttribute("context") == "progresscontext") {
			if (!db_paused[i]) pauseresumeTog(dbelems[i], null);
		}
		i = i + 1;
	}
}

function resumeall() {
	var dbelems = document.getElementById("downbar").childNodes;
	var i = 1;
	while (i < dbelems.length) {
		if (dbelems[i].getAttribute("context") == "progresscontext") {
			if (db_paused[i]) pauseresumeTog(dbelems[i], null);
		}
		i = i + 1;
	}
}

function stopall() {
	
	var dbelems = document.getElementById("downbar").childNodes;
	for (i = 1; i <= dbelems.length - 1; ++i) {
		if (dbelems[i].getAttribute("context") == "progresscontext") {
			//db_requests.splice(i,1);
			//db_paused.splice(i,1);
			db_gDownloadManager.cancelDownload(dbelems[i].id);
		}
	}
	
}

function copyURL(elemtocopy) {
	
	const gClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"]
														.getService(Components.interfaces.nsIClipboardHelper);
	gClipboardHelper.copyString(document.getElementById(elemtocopy).getAttribute("pURL"));
}

function startit(elemid) {  // - Experimental resume across session -

	var dbelems = document.getElementById("downbar").childNodes;
	for (i = 1; i <= dbelems.length - 1; ++i) {
		if (dbelems[i].id == elemid) {
			db_requests.splice(i,1);
			db_paused.splice(i,1);
		}
	}
	var aElem = document.getElementById(elemid);
	var sourcepath = aElem.getAttribute("sourcepath");
	var aFilename = aElem.firstChild.value;
	
	// alert("Attempting to resume:  " + aFilename + ".\n" + " You must save the file to:  " + elemid);
	
	var browser = top.document.getElementById("content");  
  	var aThing = browser.loadURI(sourcepath, getReferrer(document));
}

function stopit(elemtostop) {

	//var dbelems = document.getElementById("downbar").childNodes;
	//for (i = 1; i <= dbelems.length - 1; ++i) {
	//	if (dbelems[i].id == elemtostop) {
	//		db_requests.splice(i,1);
	//		db_paused.splice(i,1);
	//	}
	//}
	db_gDownloadManager.cancelDownload(elemtostop);
	//checkHeight();
	
}

function hideit(elemtohide) {
	document.getElementById(elemtohide).hidden = true;
	document.getElementById(elemtohide).setAttribute("style", "margin: 0px;");
	//checkHeight();
}

function unhideall() {
	/*var dbelems = document.getElementById("downbar").childNodes;
	for (i = 1; i <= dbelems.length - 1; ++i) {
		if (dbelems[i].hidden) dbelems[i].hidden = false;
	}*/
	document.getElementById("downbar").builder.rebuild();
	setAllDisplayItems();
	//checkHeight();
}

function labeldecide(elem) {
	if (elem.pPaused) document.getElementById("PauResLabel").label = "Resume";
	else document.getElementById("PauResLabel").label = "Pause";
}

function updatecurrent(newelemid) {
	db_currentelem = newelemid;
}

function createLocalFile(aFilePath)
{
  var lfContractID = "@mozilla.org/file/local;1";
  var lfIID = Components.interfaces.nsILocalFile;
  var lf = Components.classes[lfContractID].createInstance(lfIID);
  lf.initWithPath(aFilePath);
  return lf;
}

function setAllDisplayItems() {
	var dbelems = document.getElementById("downbar").childNodes;
	var numtrue = db_displayprefs[5];
	
	// Set the paused state and the display items
	for (i = 1; i <= dbelems.length - 1; ++i) {
		if (dbelems[i].getAttribute("context") == "progresscontext") {
			if (db_paused[i]) {
				dbelems[i].setAttribute("style", "border: 1px solid red;");
				dbelems[i].pPaused = true;
			}
			else dbelems[i].setAttribute("style", "border: 1px solid threeDShadow;");
			
			// If there is only one displayed, make is bigger
			if (numtrue < 2) {				
				dbelems[i].lastChild.lastChild.firstChild.setAttribute("style", "font-size: 7pt; font-weight: normal;");
				dbelems[i].lastChild.lastChild.firstChild.nextSibling.setAttribute("style", "font-size: 7pt; font-weight: normal;");
				dbelems[i].lastChild.lastChild.lastChild.previousSibling.setAttribute("style", "font-size: 6pt; font-weight: bold;");
				dbelems[i].lastChild.lastChild.lastChild.setAttribute("style", "font-size: 7pt; font-weight: normal;");
			}
			else {
				dbelems[i].lastChild.lastChild.firstChild.setAttribute("style", "font-size: 5pt; font-weight: bold;");
				dbelems[i].lastChild.lastChild.firstChild.nextSibling.setAttribute("style", "font-size: 5pt; font-weight: bold;");
				dbelems[i].lastChild.lastChild.lastChild.previousSibling.setAttribute("style", "font-size: 5pt; font-weight: bold;");
				dbelems[i].lastChild.lastChild.lastChild.setAttribute("style", "font-size: 5pt; font-weight: bold;");
			}
			
			// Choose which items are displayed
			if (db_displayprefs[0]) dbelems[i].lastChild.lastChild.firstChild.hidden = false;
			else dbelems[i].lastChild.lastChild.firstChild.hidden = true;
			if (db_displayprefs[1]) dbelems[i].lastChild.lastChild.firstChild.nextSibling.hidden = false;
			else dbelems[i].lastChild.lastChild.firstChild.nextSibling.hidden = true;
			if (db_displayprefs[2]) dbelems[i].lastChild.lastChild.lastChild.previousSibling.hidden = false;
			else dbelems[i].lastChild.lastChild.lastChild.previousSibling.hidden = true;
			if (db_displayprefs[3]) dbelems[i].lastChild.lastChild.lastChild.hidden = false;
			else dbelems[i].lastChild.lastChild.lastChild.hidden = true;
			
			var percentC = db_gDownloadManager.getDownload(dbelems[i].id).percentComplete;
			dbelems[i].firstChild.setAttribute("value", percentC);
			dbelems[i].lastChild.lastChild.firstChild.setAttribute("value", percentC + "%");
			dbelems[i].lastChild.lastChild.firstChild.nextSibling.value = 0;
		}
	}
}

/*function checkHeight () {
	
	var downbarelem = document.getElementById("downbar");	
	
	if (downbarelem.boxObject.height > 15) 
		downbarelem.setAttribute("style", "border: 1px solid ThreeDShadow;");
	else
		downbarelem.setAttribute("style", "border: 0px solid ThreeDShadow;");

}*/

function repeattooltip() {
	var elem = document.getElementById(db_currentelem);
	elem.pIvalCode = window.setInterval("maketooltip()", 1000);
}

function stoptooltip() {
	var elem = document.getElementById(db_currentelem);
	window.clearInterval(elem.pIvalCode);
}

function maketooltip() {
	var elem = document.getElementById(db_currentelem);
	if (!elem.lastChild.lastChild) {							// need to fix in firebird
		stoptooltip();											//
	}															//	
	else {														//
		var source = elem.getAttribute("pURL");
		var target = elem.id;
		var percent = elem.lastChild.lastChild.firstChild.value;
		var speed = elem.lastChild.lastChild.firstChild.nextSibling.value;
		
		if (elem.pSavedBytes && elem.pTotalBytes) {
			var currbytes = elem.pSavedBytes;
			var totalbytes = elem.pTotalBytes;
			
			var currkb = parseInt(currbytes / 1024); // KBytes
			var totalkb = parseInt(totalbytes / 1024); // KBytes
			var remainingkb = totalkb - currkb;
		}
		else {
			var currkb = "Unknown";
			var totalkb = "Unknown";
		}
		
		var remaintime;
		if (speed == 0)  // Don't want to divide by zero
				remaintime = "Unknown";
		else {
			var secsleft = (1 / speed) * remainingkb;
			var remaintime = formatSeconds(secsleft);
		}
		if (elem.pTotalBytes == "-1")  {  // If the mode is undetermined, we won't know these
			percent = "Unknown";
			totalkb = "Unknown";
			remaintime = "Unknown";
		}
		
		document.getElementById("source").value = source;
		document.getElementById("target").value = target;
		document.getElementById("status").value = currkb  + " KB of " + totalkb + " KB (at " + speed + " KB/sec)";
		document.getElementById("timeLeft").value = remaintime;
		document.getElementById("percentText").value = percent;
	}
	
}

function repeatDBtooltip() {
	
	if (document.tooltipNode.getAttribute("id") != "downbar") return false; // if we are on a progress elem we don't want to show this tooltip
	
	makeDBtooltip();
	var dbelem = document.getElementById("downbar");
	dbelem.dbIvalCode = window.setInterval("makeDBtooltip()", 1000);
	return true;
}

function stopDBtooltip() {
	var dbelem = document.getElementById("downbar");
	window.clearInterval(dbelem.dbIvalCode);
}

function makeDBtooltip() {
	
	var dbelem = document.getElementById("downbar");
	var dbelems = document.getElementById("downbar").childNodes;
	var unknownAdd = "";
	var numProg = 0;
	var sumProgSpeeds = 0;
	var sumProgSize = 0;
	var totalProgSize = 0;
	
	for (i = 1; i <= dbelems.length - 1; ++i) {
		if (dbelems[i].getAttribute("context") == "progresscontext") {
			if (db_paused[i]) {}
			else {
				numProg = numProg + 1;
				sumProgSpeeds = sumProgSpeeds + parseInt(dbelems[i].lastChild.lastChild.firstChild.nextSibling.value);
				sumProgSize = sumProgSize + dbelems[i].pSavedBytes;
				totalProgSize = totalProgSize + dbelems[i].pTotalBytes;
			
				if (dbelems[i].pTotalBytes == "-1") {
					unknownAdd = " + Unknown time";
				}
			}
		}
	}
	
	var currkb = parseInt(sumProgSize / 1024); // KBytes
	var totalkb = parseInt(totalProgSize / 1024); // KBytes
	
	var remainingkb = totalkb - currkb;
	var secsleft;
	if (sumProgSpeeds == 0 | totalProgSize == "-1")  // don't want to divide by zero
				secsleft = 0;
	else
				secsleft = (1 / sumProgSpeeds) * remainingkb;
				
	var remaintime = formatSeconds(secsleft);
		
	document.getElementById("numFinished").value = db_totalFinished;
	document.getElementById("sizeFinished").value = db_totalSize + " KB";
	document.getElementById("numUnfinished").value = numProg;
	document.getElementById("speedUnfinished").value = sumProgSpeeds + " KB/sec";
	document.getElementById("timeUnfinished").value = remaintime + unknownAdd;
}

function formatSeconds (secs) {
// Round the number of seconds to remove fractions.
	secs = parseInt( secs + .5 );
	var hours = parseInt( secs/3600 );
	secs -= hours*3600;
	var mins = parseInt( secs/60 );
	secs -= mins*60;
	var result;
	
    if ( mins < 10 )
        mins = "0" + mins;
    if ( secs < 10 )
        secs = "0" + secs;
    
    if (hours) {
    	if ( hours < 10 ) hours = "0" + hours;
    	result = hours + ":" + mins + ":" + secs;
	}
	else result = mins + ":" + secs;
    
    return result;
}

function readPrefs () {
	// Get and save display prefs
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	
	try {
		db_displayprefs[0] = pref.getBoolPref("downbar.display.percent");
		db_displayprefs[1] = pref.getBoolPref("downbar.display.speed");
		db_displayprefs[2] = pref.getBoolPref("downbar.display.size");
		db_displayprefs[3] = pref.getBoolPref("downbar.display.time");
	}
	catch (e){}
	
	// Find the number of items displayed (used in setAllDisplayItems)
	var numtrue = 0;
	for (i = 0; i <= 3; ++i) {
		if (db_displayprefs[i]) 
			numtrue = numtrue + 1;
	}
	db_displayprefs[5] = numtrue;
}

function middleClickRemove(aElem, aEvent) {
	
	if (aEvent.button == 1) {
		removeit(aElem.id, false);
	}
	
}

function checkChildren() {
	var downbarelem = document.getElementById("downbar")
	var dbelems = downbarelem.childNodes;
	
	if (downbarelem.lastChild.id == lastID) {
		var i = 1;
		var db_dl;
		while (i < dbelems.length) {
			if (dbelems[i].getAttribute("context") == "progresscontext") {
				db_dl = db_gDownloadManager.getDownload(dbelems[i].id);
				db_dl.listener = dbListener;
			}
			i = i + 1;
		}
	}
	lastID = downbarelem.lastChild.id;
}

/* function expandtowindow (elemid) {  // Depreciated - Now showing tooltip instead - could come back in the future
	
	//db_gDownloadManager.openProgressDialogFor(elemid, window);
	//Ugly fix for now
	
	var pdialog = Components.classes["@mozilla.org/progressdialog;1"].createInstance(Components.interfaces.nsIProgressDialog);	
	var dl = pdialog.QueryInterface(Components.interfaces.nsIDownload);
	var adownload = Components.classes["@mozilla.org/download;1"].createInstance(Components.interfaces.nsIDownload);
	adownload = db_gDownloadManager.getDownload(elemid);
	//pdialog.cancelDownloadOnClose = false;  Not needed because the dialog is not connected to the download, the dialog is just listening
   
	dl.init(adownload.source, adownload.target, null, adownload.MIMEInfo, adownload.startTime, null);
  
	var dialistener = pdialog.QueryInterface(Components.interfaces.nsIWebProgressListener);
	adownload.listener = dialistener; 
	//internalDownload->SetDialog(pdialog); Can I do this in java? Need to access the nsdownload not the nsIDownload.
	//This would connect the download to the dialog, ie cancel download button would work on the dialog.
	pdialog.open(window);
	window.setTimeout(changecloselabel, 100);
	
	//old version 0.5
	//db_gDownloadManager.openProgressDialogFor(elemid, window);
	//document.getElementById(elemid).hidden = true;
	//access widow-mediator - dialog - CloseDownloadOnClose = false
	//old
}*/

/*function changecloselabel(){ // Depreciated - used with expand to window
	var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
	ww.activeWindow.document.getElementById("cancel").label = "Close"
	ww.activeWindow.document.getElementById("pauseResume").hidden = "true"
}*/

// In the future use a separate window and keep track of where it should be with boxObject stuff
//var statbar = document.getElementById("status-bar");
//acs.logStringMessage(statbar.boxObject.height + " - " + statbar.boxObject.width + " - " + statbar.boxObject.x + " - " + statbar.boxObject.y);
